library(data.table)
library(dplyr)

read2pgwaOS <- function(path,pathc,id,fpa)
{ 
 dlist <- list() 
  trlist<- list()
  readlist <- list.files(path,pattern=paste0('*.',fpa))
  for (trnum in readlist)
  {print(paste0('NOTE: Assuming SNP effects are calculated with the same allele in different populations/traits and the order of SNPs in all mlma files are the same. If NOT, please use read2pgwa.R'))
   print(paste0('population 1 tr',trnum,' started at ',Sys.time()))
     dg <- nchar(length(readlist))
     trord <- sprintf(paste0('%0.',dg,'d'),which(as.character(readlist)==as.character(trnum)))
     if(trord==sprintf(paste0('%0.',dg,'d'),1))
     {refd <- fread(paste0(path,trnum))
     trlist[[trnum]] <- refd[,c(2,1,3,7:9)]
     colnames(trlist[[trnum]])[4:6] <- paste0('tr',trord,'.',colnames(trlist[[trnum]])[4:6])
#    setkeyv(trlist[[trnum]],id)
     }else
     {
#     tmp <- fread(paste0(path,trnum))
#     tmp1 <- merge(tmp,refd[,c(2,4,5)],by=id,sort=F)
#     tmp1[,b:=ifelse(A1.x==A1.y,b,-1*b)]
#     tmp1 <- merge(tmp,refd[,c(2,4,5)],by=id,sort=F)
      tmp1 <- fread(paste0(path,trnum))
      trlist[[trnum]] <- tmp1[,c(7:9)]
      colnames(trlist[[trnum]]) <- paste0('tr',trord,'.',colnames(trlist[[trnum]]))
#     setkeyv(trlist[[trnum]],id)
      }
  }
  print(paste0('reading population 1 data finished, merge started at ',Sys.time()))
#  dt <- Reduce(function(...) merge(...,by=id,all=T,sort=F),trlist)
#  dt <- Reduce(cbind,trlist) 
   dt <- bind_cols(trlist)
   
  print(paste0('Combime population 1 data finished at ',Sys.time()))
 dlist[['dt1']] <- dt
#-----read another one
  ctrlist<- list()
  readlist <- list.files(pathc,pattern='*.mlma')
  for (trnum in readlist)
  {print(paste0('population 2 tr',trnum,' started at ',Sys.time()))
     dg <- nchar(length(readlist))
     trord <- sprintf(paste0('%0.',dg,'d'),which(as.character(readlist)==as.character(trnum)))
#     tmp <- fread(paste0(pathc,trnum))
#     tmp1 <- merge(tmp,refd[,c(2,4,5)],by=id,sort=F,all=T)
#     tmp1[,b:=ifelse(A1.x==A1.y,b,-1*b)]
     if(trord==sprintf(paste0('%0.',dg,'d'),1))
     {refd <- fread(paste0(pathc,trnum))
     ctrlist[[trnum]] <- refd[,c(2,7:9)]
     colnames(ctrlist[[trnum]])[2:4] <- paste0('tr',trord,'.',colnames(ctrlist[[trnum]])[2:4])
     } else
     { 
      tmp1 <- fread(paste0(pathc,trnum))
      ctrlist[[trnum]] <- tmp1[,c(7:9)]
      colnames(ctrlist[[trnum]]) <- paste0('tr',trord,'.',colnames(ctrlist[[trnum]]))
#     setkeyv(ctrlist[[trnum]],id)

     }
   }
  print(paste0('reading population 2 data finished, merge started at ',Sys.time()))
# cdt <- Reduce(function(...) merge(...,by=id,all=T,sort=F),ctrlist)
# cdt <- Reduce(cbind,ctrlist)
  cdt <- bind_cols(ctrlist)
  print(paste0('Combine population 2 data finished at ',Sys.time()))
 dlist[['dt2']] <- cdt
 return(dlist)
}

