#take gwas read obj to do multi-trait meta-analysis (within that population)
library(data.table)
library(qvalue)
#path2 <-  paste0('/group/dairy/for_Ruidong_multitrait/rx01/bin/mgram25012018/gwasign/updraw04042019/functest/bullmlma/testtr/')
#dt <- read.gwa(path2)

#id <- 'SNP'
#chr <- 'Chr'
#bp <- 'bp'
#bpa <- 'b'
#sepa <- 'se'

etme <- function(dt,id,chr,bp,bpa,sepa) 
{print(paste0('reading data started at ',Sys.time()))
tv <- dt[,grep(paste0('.',bpa,'$'),colnames(dt)),with=F]/dt[,grep(paste0('.',sepa,'$'),colnames(dt)),with=F]
tv[,df:=rowSums(!is.na(tv))]
print(paste0('df calculated at ',Sys.time()))
f_dowle2 = function(DT) {
  for (i in names(DT))
    DT[!is.finite(get(i)), (i):=0]
    }
f_dowle2(tv)
ivcormat <- solve(cor(tv[,-ncol(tv),with=F]))
print(paste0('cormat inverted at ',Sys.time()))
tv[,x2:=rowSums(as.matrix(tv[,-ncol(tv),with=F]) %*% ivcormat * as.matrix(tv[,-ncol(tv),with=F]))]
if (tv[!is.finite(x2),.N]> tv[,.N]/2) {
print(paste0('more than half chi-square values are not estimable, something is wrong with t values (t mat returned)'))
break
return(tv)}
print(paste0('X2 calculated at ',Sys.time()))
tv[,X2.p:=pchisq(x2,df=df,lower.tail=F)]
print(paste0('p val of X2 calculated at ',Sys.time()))
tv[,fdr:=qvalue(p=X2.p)$qvalues]
#tv[,fdr:=ifelse(is.infinite(X2.p)|is.na(X2.p),NA,qvalue(p=X2.p)$qvalues)]
print(paste0('FDR calculated at ',Sys.time()))
tv1 <- cbind(dt[,which(colnames(dt) %in% c(id,chr,bp)),with=F],tv[,c(ncol(tv)-3,ncol(tv)-2,ncol(tv)-1,ncol(tv)),with=F])
print(paste0('meta-analysis finished at ',Sys.time()))
return(tv1)
}

