#this file contains dot product calculation of multi-trait fdred
library(data.table)

edmedpd <- function(dlist,id,chr,bp,bpa,sepa)
{print(paste0('read data at ',Sys.time()))
  tvdt <- merge(cbind(dlist[[1]][,which(colnames(dlist[[1]]) %in% c(id,chr,bp)),with=F],dlist[[1]][,grep(paste0('.',bpa),colnames(dlist[[1]])),with=F]/dlist[[1]][,grep(paste0('.',sepa),colnames(dlist[[1]])),with=F]),cbind(dlist[[2]][,which(colnames(dlist[[2]]) %in% id),with=F],dlist[[2]][,grep(paste0('.',bpa),colnames(dlist[[2]])),with=F]/dlist[[2]][,grep(paste0('.',sepa),colnames(dlist[[2]])),with=F]),by=id,sort=F)
  colnames(tvdt) <- gsub('.b.','.t.',colnames(tvdt))
  print(paste0('data merged at ',Sys.time()))
  tvdt[,pi:=rowSums(tvdt[,grep('.t.x',colnames(tvdt)),with=F] * tvdt[,grep('.t.y',colnames(tvdt)),with=F],na.rm=T)]
  print(paste0('dot product calculated at ',Sys.time()))
return(tvdt[,c(colnames(tvdt) %in% c(id,chr,bp,'pi')),with=F])
}

